java自定义异常以及throw和throws关键字-知了汇智

java自定义异常以及throw和throws关键字

  java中内置了很多可能在编程时出现的大部分异常。除此之外,用户可以使用一个类继承Exception类即可继承自定义类异常。

  在程序中自定义类,大体上分为以下几个步骤:

  1.创建自定义异常类

  2.在方法中通过throw关键字抛出异常对象。

  3.如果在当前抛出异常的方法中处理异常,可以使用try-catch语句块捕捉并处理异常,否则在方法的声明处通过throws指明要抛出给方法调用者的异常,继续进行下一步操作。

  4.再出现异常的方法的调用者中捕获处理异常。

  下面是我创建自定义异常。在项目中创建类MyException,该类继承Exception。

public class MyException extends Exception{  //创建自定义异常
public MyException(String ErrorExceptin){	//构造方法
	super(ErrorExceptin);		//父类构造方法
}
}

  在项目中创建类TestException,在该类中创建一个带int型参数的方法Sum(),该方法参数是否小于0或大于20,通过throw关键字抛出一个MyException异常对象,并在main()中捕获异常。下面是代码实例。

public class TestException {
//定义方法,抛出异常
private static int Sum(int num1,int num2)throws MyException{
	if(num1<0||num2<0){				 //判断方法中参数是否满足条件
		throw new MyException("输入参数为负数"); //错误信息
	}
	if(num1>20||num2>20){				//判断方法中参数是否满足条件
		throw new MyException("输入参数大于20");//错误信息
	}
	return (num1+num2);				//将两个数的和输出
}
public static void main(String []args){
	try {						//try代码块处理可能出现的异常
		int result=Sum(22,23);			//调用Sum()方法
		System.out.println(result);		//将Sum()方法的返回值输出
	} catch (MyException e) {		
		// TODO: handle exception
		System.out.println(e);			//输出异常信息
	}
}
}

  输出结果:

java自定义异常以及throw和throws关键字

 

  上面说的是如何定义一个自定义异常,那么接下来说说,如何在方法中抛出异常呢?

  若是某个方法可能发生异常,但不想在当前方法中处理这个异常,则可以使用throws、throw关键字在方法中抛出异常。

  throws通常用在声明方法时,用来制指定可能抛出的异常。多个异常可以使用逗号分隔。

  throw关键字通常用于方法体中,并且抛出一个异常对象。程序在执行到throw语句时立即终止,它后面的语句都不执行。通过throw抛出异常后,如果想在上一级代码中来捕获并处理异常,则需要在抛出异常的方法中使用throws关键字在方法的声明中指明要抛出的异常;如果要捕获throw抛出的异常,则必须使用try-catch语句块;

  下面是一个空指针的例子的例子;

public class NullpointExceptionTest {
static void testNull()throws NullPointerException{
	String s = null;
	if(s==null){
		throw new NullPointerException();
	}
}
public static void main(String []args){
	try {
		testNull();
	} catch (NullPointerException e) {
		// TODO: handle exception
		System.out.println("testNull()中抛出的异常是"+e);
	}
}
}

  输出结果:

java自定义异常以及throw和throws关键字

 

  注意:如果是Error、RuntimeException或它们的子类,可以不使用throws关键字来声明要抛出的异常,编译仍能顺利通过,但在系统运行时会被系统抛出。如果有多个catch语句块处理异常,但是catch(Exception e)代码块放在其他代码的前面的画,后面的代码就得不到执行,后面的代码块将得不到执行。

  RuntimeException异常是程序运行过程中产生的异常,java类库的每个包中都定义了异常类,所有这些类都是Throwable的子类。Throwable派生了两个子类,分别是Exception和Error类。Error类及其子类用来描述java系统中的内部错误以及资源耗尽的错误,这类错误比较严重。Exception类被称为非致命类,可以通过捕捉处理是程序继续执行。Exception类有根据错误发生的原因分为RuntimeException异常和RuntimeException异常之外的异常。这些常见的异常都可以通过try-catch语句来捕捉。

  java异常机制用户去考虑程序的强制性和安全性。异常处理不应用来控制程序的正常流程,其主要作用是捕获程序在运行时发生的异常并进行相应的处理。编写代码处理某个方法时可能出现的异常时,可遵循以下几条原则:

  1.在当前方法声明中使用try-catch语句捕获异常。

  2.在一个方法被覆盖时,覆盖它的方法必须抛出相应的异常或者异常的子类。

  3.如果父类抛出多个异常,则覆盖的方法必须抛出那些异常的一个子集,不能抛出新的异常。
 

  版权声明:本文来源于网络,由知了堂搜集整理,仅供大家学习Java时使用

项目教学·项目驱动

132 2811 3191
预约免费试学
点击咨询
预约试学